<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightSupplement extends AbstractStructArrayBase
{
    /**
     * The FlightSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightSupplement[]
     */
    public $FlightSupplement;
    /**
     * Constructor method for ArrayOfJP_FlightSupplement
     * @uses ArrayOfJP_FlightSupplement::setFlightSupplement()
     * @param \StructType\JP_FlightSupplement[] $flightSupplement
     */
    public function __construct(array $flightSupplement = array())
    {
        $this
            ->setFlightSupplement($flightSupplement);
    }
    /**
     * Get FlightSupplement value
     * @return \StructType\JP_FlightSupplement[]|null
     */
    public function getFlightSupplement()
    {
        return $this->FlightSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightSupplementForArrayConstraintsFromSetFlightSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FlightSupplementFlightSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightSupplementFlightSupplementItem instanceof \StructType\JP_FlightSupplement) {
                $invalidValues[] = is_object($arrayOfJP_FlightSupplementFlightSupplementItem) ? get_class($arrayOfJP_FlightSupplementFlightSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_FlightSupplementFlightSupplementItem), var_export($arrayOfJP_FlightSupplementFlightSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightSupplement property can only contain items of type \StructType\JP_FlightSupplement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplement[] $flightSupplement
     * @return \ArrayType\ArrayOfJP_FlightSupplement
     */
    public function setFlightSupplement(array $flightSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($flightSupplementArrayErrorMessage = self::validateFlightSupplementForArrayConstraintsFromSetFlightSupplement($flightSupplement))) {
            throw new \InvalidArgumentException($flightSupplementArrayErrorMessage, __LINE__);
        }
        $this->FlightSupplement = $flightSupplement;
        return $this;
    }
    /**
     * Add item to FlightSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplement $item
     * @return \ArrayType\ArrayOfJP_FlightSupplement
     */
    public function addToFlightSupplement(\StructType\JP_FlightSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightSupplement) {
            throw new \InvalidArgumentException(sprintf('The FlightSupplement property can only contain items of type \StructType\JP_FlightSupplement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSupplement
     */
    public function getAttributeName()
    {
        return 'FlightSupplement';
    }
}
